<!DOCTYPE html>
<html lang="en">
	<head>
		<title>Task bs150 detail of posts</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	</head>

	<body onload="onPageLoad()">
		<div class="container jumbotron bg-light">
			<h3 class="text-center text-info mb-4">
				Chi tiết Post - Chi tiết bài đăng
			</h3>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">id: </label>
				<div class="col-sm-9">
					<input
						type="text"
						class="form-control"
						id="inp-id"
						placeholder="..."
					/>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label"> Post (bài viết) id: </label>
				<div class="col-sm-9">
					<input
						type="text"
						class="form-control"
						id="inp-post-id"
						placeholder="..."
					/>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label"> Email: </label>
				<div class="col-sm-9">
					<input
						type="text"
						class="form-control"
						id="inp-email"
						placeholder="..."
					/>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">Name (nhan đề): </label>
				<div class="col-sm-9">
					<input type="text" class="form-control" id="inp-name" />
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label"> Body (nội dung): </label>
				<div class="col-sm-9">
					<textarea
						rows="5"
						class="form-control"
						placeholder="nội dung post"
						id="area-body"
					>
					</textarea>
				</div>
			</div>
		</div>
	</body>
	<script>
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		// hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
		function onPageLoad() {
			//1.đọc dữ liệu
			var vpostIdObject = { Id: '' };
			readDatapostIdObject(vpostIdObject);
			//2.kiểm tra
			var vKetQuaKiemTra = validatepostIdObject(vpostIdObject);
			if (vKetQuaKiemTra) {
				//3. gọi server
				//base url
				const vURL_GET_POST_DETAIL =
					'https://jsonplaceholder.typicode.com' +
					'/comments/' +
					vpostIdObject.Id;
				$.ajax({
					url: vURL_GET_POST_DETAIL,
					type: 'GET',
					dataType: 'json', // added data type
					success: function (responseObject) {
						console.log(JSON.stringify(responseObject)); //response text
						//bước 4. xử lý hiện thị
						hienThiDuLieuPost(responseObject); //chính là post object
					},
					error: function (ajaxContext) {
						alert(ajaxContext.responseText);
					},
				});
			}
		}
		//hiện thị dữl iệu pôst
		function hienThiDuLieuPost(paramPostObject) {
			$('#inp-id').val(paramPostObject.id);
			$('#inp-post-id').val(paramPostObject.postId);
			$('#inp-email').val(paramPostObject.email);
			$('#inp-name').val(paramPostObject.name);
			$('#area-body').val(paramPostObject.body);
		}
		// read data
		function readDatapostIdObject(parampostIdObject) {
			var vUrlString = window.location.href;
			var vURL = new URL(vUrlString);
			var vId = vURL.searchParams.get('id');

			parampostIdObject.Id = vId;
		}

		// validate data
		function validatepostIdObject(parampostIdObject) {
			if (parampostIdObject.Id === '') {
				alert('Dữ liệu cần truyền vào !');
				return false;
			}
			if (isNaN(parampostIdObject.Id)) {
				alert('Dữ liệu là số nguyên !');
				return false;
			}
			return true;
		}
	</script>
</html>
